include image.e
include file.e
without warning

sequence int,seq,cmd,files,tmpfiles,filename,filelist
integer width,height,null

-- Read the command line
    cmd=command_line()
    if length(cmd)>3 then
        filename=cmd[4] -- set the output filename
        cmd=cmd[3]
        filelist="File List in " & filename & ".gfx:" & "\n"
    else
        puts(1,"Command line:\n\n")
        puts(1,"    ex makegfx.ex c:\\mydir\\ newfile\n\n")
        puts(1,"Where: mydir is the directory where your bitmaps are and\n")
        puts(1,"       newfile is the new file to create (no extension)")
        abort(1)
    end if

-- Check if user directory finishes with "\"
    if cmd[length(cmd)] != '\\' then 
        cmd=cmd & "\\"
    end if

-- Get a sequence with the filenames of every .BMP file in
-- this dir

    files=dir(cmd)
    files=files[3..length(files)]
    tmpfiles={}
    for ax=1 to length(files) do
        if compare(files[ax][1][length(files[ax][1])-3..length(files[ax][1])],
                   ".BMP")=0 then
            tmpfiles=append(tmpfiles,files[ax][1])
        end if
    end for
    files=tmpfiles              
    int={length(files)} -- Start final variable with the number of images

-- Loop for each file in the "files" sequence, adding the data in the final
-- variable
    for ax=1 to length(files) do
        filelist=filelist & files[ax] & '\n'
        seq=read_bitmap(cmd & files[ax]) -- Read the bitmap
        seq=seq[2]

        width=length(seq[1]) height=length(seq)

        int=int & {floor(width/10),remainder(width,10), --The image size
             floor(height/10),remainder(height,10)}
        for y=1 to height do
            int=int & seq[y]  -- Add row after row
        end for
end for
-- Save the data in a single file
    null=open(filename & ".gfx","wb") 
        puts(null,int)
    close(null)
    
    null=open(filename & ".lst","w")
        puts(null,filelist)
    close(null)

